require "import"
import "android.widget.*"
import "com.androlua.*"
import "android.content.Context"
import "android.os.Vibrator"
import "android.content.Intent"
import "android.net.Uri"
import "android.view.KeyEvent"

-- Mensaje de bienvenida
local bienvenidaMensaje = [[
¡Bienvenidos a la comunidad Inclusión Tecnológica Oficial!
Nos complace invitarte a formar parte de nuestra comunidad.
A continuación, encontrarás los enlaces, para que te puedas unir a nuestras plataformas.
Al igual que nuestro grupo de amistad en WhatsApp, que es el último botón que aparece.
Atentamente,
Boliviano GT.
]]

-- Enlaces
local enlaces = {
  WhatsApp = "https://chat.whatsapp.com/Gwsi4IJQiMT5X6O1bMZztG",
  YouTube = "https://www.youtube.com/@Inclusi%C3%B3ntecnol%C3%B3gica",
  Telegram = "https://t.me/+P4grsM7ucVo1NzIx",
  GrupoReyesMundiales = "https://chat.whatsapp.com/ENkjgxfXw8QKAqWKfUsjO8", -- Clave corregida
}

-- Contexto y vibrador
local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)

-- Vibración inicial
vibrator.vibrate(100)

-- Layout principal
layout = {
  LinearLayout,
  orientation = "vertical",
  layout_width = "match_parent",
  layout_height = "match_parent",
  {
    TextView,
    text = bienvenidaMensaje,
    textSize = "18sp",
    gravity = "center",
    padding = "16dp",
    layout_width = "match_parent",
    layout_height = "wrap_content",
  },
  {
    Button,
    text = "Grupo De WhatsApp, @Inclusión Tecnológica Oficial",
    onClick = function(view)
      openLink(enlaces.WhatsApp)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Canal De YouTube, @Inclusión Tecnológica Oficial",
    onClick = function(view)
      openLink(enlaces.YouTube)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Canal De Telegram, @Inclusión Tecnológica Oficial",
    onClick = function(view)
      openLink(enlaces.Telegram)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Grupo De Amistad En WhatsApp, @Los Reyes Mundiales 👑",
    onClick = function(view)
      openLink(enlaces.GrupoReyesMundiales)
    end,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    layout_margin = "8dp",
  },
  {
    Button,
    text = "Cerrar",
    onClick = function(view)
      dlg.dismiss()
      vibrator.vibrate(100)
    end,
    layout_width = "wrap_content",
    layout_height = "wrap_content",
    layout_gravity = "end",
    layout_margin = "8dp",
  },
}

-- Crear diálogo
dlg = LuaDialog(service)
dlg.View = loadlayout(layout)

-- Función para abrir un enlace
function openLink(url)
  if not url then
    service.asyncSpeak("El enlace no está disponible.")
    return
  end
  dlg.dismiss() -- Cierra el diálogo antes de abrir el enlace
  local intent = Intent(Intent.ACTION_VIEW)
  intent.setData(Uri.parse(url))
  context.startActivity(intent)
  service.asyncSpeak("El enlace se ha abierto.")
end

-- Mostrar el diálogo
dlg.show()

-- Capturar evento de tecla "Back" para cerrar el diálogo
function onKeyDown(code, event)
  if code == KeyEvent.KEYCODE_BACK then
    dlg.dismiss()
    return true
  end
end

return true